/* 
GameBase	->	
Code		->	Roman Hoegg, 2004
License		->	BSD License
*/

#include "_variables.h"			// include shared variables, definitions, etc.

#ifdef DREAMCAST
#include <kos.h>
#endif

int intLives;
int intPoints;
int intCoins;
int intTime;
int ScaleValue;
bool ShowIntro = true;
bool PlayMusic = true;

int main(int argc, char* argv[])
{
	#ifdef DREAMCAST
		printf("Starting...\n");
		fs_chdir("/cd");
	#endif
	loadGameConfiguration();
	initSDL();
	defineTiles(0);
    defineEnemies();
	defineBonus();
	definePlayer();
	defineStages();
    definePlatforms();
    defineSounds();
	setSurfaces();
	SDL_ShowCursor (SDL_DISABLE);
    pick_system();

	//*********************************
	// terminate program
	//SDL_JoystickClose(pStick);
    Mix_AllocateChannels(0);    //deallocate channels
    Mix_FreeChunk(WavChunk[0]); //free the chunks
    Mix_FreeChunk(WavChunk[1]); //free the chunks
    Mix_FreeChunk(WavChunk[2]); //free the chunks
    Mix_CloseAudio();           //close sdl_mixer
	fprintf(stdout,"\nprogramm terminated properly!\ngood bye & thanks for playing!\n"); 	//normal termination
	exit(1);
	//*********************************
	return(0);
}

void loadGameConfiguration()
{
    ScaleValue = 1;
    iniValue = readFromINI(INI_FILENAME, "General", "Scale");
    ScaleValue = atoi(iniValue);
    free(iniValue);
    if(ScaleValue>4){ScaleValue=4;}
    if(ScaleValue<1){ScaleValue=1;}

    iniValue = readFromINI(INI_FILENAME, "General", "Fullscreen");
    if(atoi(iniValue) == 1){getInput();DisplaySurface = SDL_SetVideoMode(SCREENWIDTH*ScaleValue, SCREENHEIGHT*ScaleValue, 16, SDL_SWSURFACE|SDL_FULLSCREEN);}
    else{DisplaySurface = SDL_SetVideoMode(SCREENWIDTH*ScaleValue, SCREENHEIGHT*ScaleValue, 16, SDL_ANYFORMAT);}
    free(iniValue);

    StartStage = 1; // default value...
    iniValue = readFromINI(INI_FILENAME, "General", "Start_Stage");
    StartStage = atoi(iniValue);
    free(iniValue);
    
    StartBonus = 0; // default value
    iniValue = readFromINI(INI_FILENAME, "General", "Bonus");
    StartBonus = atoi(iniValue);
    free(iniValue);
    
    StartTime = 99; // default value
    iniValue = readFromINI(INI_FILENAME, "General", "Time");
    StartTime = atoi(iniValue);
    free(iniValue);

    ShowIntro = true; // default value
    iniValue = readFromINI(INI_FILENAME, "General", "Show_Intro");
    ShowIntro = atoi(iniValue);
    free(iniValue);

    PlayMusic = true; // default value
    iniValue = readFromINI(INI_FILENAME, "General", "Play_Music");
    PlayMusic = atoi(iniValue);
    free(iniValue);

}

