#include "_variables.h"

void draw_pick_system_cursor(int SystemNumber);
Mix_Music* BackgroundMusic;

int SystemNumber;

void pick_system()
{
  SystemNumber = 0;

  
  #ifdef DREAMCAST
  BackgroundMusic=Mix_LoadMUS("base/default/intro.mod"); //load in the music
  #else
  iniValue = readFromINI("base/default/audio.ini", "Music", "Intro");
  BackgroundMusic=Mix_LoadMUS(iniValue); //load in the music
  free(iniValue);
  #endif
  if(PlayMusic){Mix_PlayMusic(BackgroundMusic,-1);} //play the music

  while(!Key_ESCAPE_pressed && !Key_ENTER_pressed)
  {
    getInput();
    drawBackground(1, 0, 0);
    draw_pick_system_cursor(SystemNumber);
    if(Key_RIGHT_pressed && SystemNumber<4){SystemNumber++;}
    if(Key_LEFT_pressed && SystemNumber>0){SystemNumber--;}
    if(Key_F11_pressed)  {getInput();DisplaySurface = SDL_SetVideoMode(SCREENWIDTH*ScaleValue, SCREENHEIGHT*ScaleValue, 16, SDL_ANYFORMAT);}
    if(Key_F12_pressed)  {getInput();DisplaySurface = SDL_SetVideoMode(SCREENWIDTH*ScaleValue, SCREENHEIGHT*ScaleValue, 16, SDL_SWSURFACE|SDL_FULLSCREEN);}
    Print(16,8,0,"pick your system (left and right)");

  if(SystemNumber==0)
  {
    Print(280,144,0,">>>");
    Print(16,160,2,"Default Version");
    Print(16,178,0,"Special Features");
    Print(16,187,0,"- not pretty (yet)");
    Print(16,196,0,"- no music (yet)");
  }

  if(SystemNumber==1)
  {
    Print(16,144,0,"<<<");
    Print(280,144,0,">>>");
    Print(16,160,2,"Amiga Version");
    Print(16,178,0,"Special Features");
    Print(16,187,0,"- arguably the best version");
    Print(16,196,0,"- most complete implementation");
  }

  if(SystemNumber==2)
  {
    Print(16,144,0,"<<<");
    Print(280,144,0,">>>");
    Print(16,160,2,"C64 Version");
    Print(16,178,0,"Special Features");
    Print(16,187,0,"- SID sound");
    Print(16,196,0,"- animated diamonds");
  }

  if(SystemNumber==3)
  {
    Print(16,144,0,"<<<");
    Print(280,144,0,">>>");
    Print(16,160,2,"Atari ST Version");
    Print(16,178,0,"Special Features");
    Print(16,187,0,"- no scrolling... LOL");
  }

  if(SystemNumber==4)
  {
    Print(16,144,0,"<<<");
    Print(16,160,2,"Amstrad CPC Version");
    Print(16,178,0,"Special Features");
    Print(16,187,0,"- was never released");
  }
/*
    Print(8,228,0,"Resolution:");
    PrintInt(100,228,0,SCREENWIDTH*ScaleValue);
    Print(136,228,0,"x");
    PrintInt(152,228,0,SCREENHEIGHT*ScaleValue);
*/
    if(SystemNumber>0){Print(88,224,1,"not yet implemented (sorry)");}
    SDL_UpdateRect(DisplaySurface,0,0,0,0);
  }


  if(SystemNumber == 1)
  {
    iniValue = readFromINI(INI_FILENAME, "Systems", "Amiga_enabled");
    if(strcmp ("1",iniValue) != 0){SystemNumber=0;}
    free(iniValue);
  }

  if(SystemNumber == 2)
  {
    iniValue = readFromINI(INI_FILENAME, "Systems", "C64_enabled");
    if(strcmp ("1",iniValue) != 0){SystemNumber=0;}
    free(iniValue);
  }

  if(SystemNumber == 3)
  {
    iniValue = readFromINI(INI_FILENAME, "Systems", "Atari_enabled");
    if(strcmp ("1",iniValue) != 0){SystemNumber=0;}
    free(iniValue);
  }

  if(SystemNumber == 4)
  {
    iniValue = readFromINI(INI_FILENAME, "Systems", "AmstradCPC_enabled");
    if(strcmp ("1",iniValue) != 0){SystemNumber=0;}
    free(iniValue);
  }
    
  getInput();

  SDL_Rect TempRect;
  TempRect.x=0;
  TempRect.y=0;

  Uint32 CKColor = SDL_MapRGB(DisplaySurface->format,255,0,255);

  if(SystemNumber==0)
  {
	//*********************************
	// generate tiles surfaces
    TilesSurface = SDL_DisplayFormat (IMG_Load("base/default/tiles.png"));
    TempRect.h=TilesSurface->h*ScaleValue;
    TempRect.w=TilesSurface->w*ScaleValue;
    TilesSurface = ScaleSurface(TilesSurface, TilesSurface->w*ScaleValue, TilesSurface->h*ScaleValue);
    SDL_SetColorKey(TilesSurface, SDL_SRCCOLORKEY, CKColor);
	//*********************************

	//*********************************
	// generate Player sprites surfaces
    PlayerSpritesSurface = SDL_DisplayFormat (IMG_Load("base/default/player.png"));
    TempRect.h=PlayerSpritesSurface->h*ScaleValue;
    TempRect.w=PlayerSpritesSurface->w*ScaleValue;
    PlayerSpritesSurface = ScaleSurface(PlayerSpritesSurface, PlayerSpritesSurface->w*ScaleValue, PlayerSpritesSurface->h*ScaleValue);
    SDL_SetColorKey(PlayerSpritesSurface, SDL_SRCCOLORKEY, CKColor);
	//*********************************

	//*********************************
	// generate enemy sprites surfaces
    EnemySpritesSurface = SDL_DisplayFormat (IMG_Load("base/default/enemies.png"));
    TempRect.h=EnemySpritesSurface->h*ScaleValue;
    TempRect.w=EnemySpritesSurface->w*ScaleValue;
    EnemySpritesSurface = ScaleSurface(EnemySpritesSurface, EnemySpritesSurface->w*ScaleValue, EnemySpritesSurface->h*ScaleValue);
    SDL_SetColorKey(EnemySpritesSurface, SDL_SRCCOLORKEY, CKColor);
	//*********************************

    //*********************************
	// generate bonus sprites surfaces
    BonusSurface = SDL_DisplayFormat (IMG_Load("base/default/bonus.png"));
    TempRect.h=BonusSurface->h*ScaleValue;
    TempRect.w=BonusSurface->w*ScaleValue;
    BonusSurface = ScaleSurface(BonusSurface, BonusSurface->w*ScaleValue, BonusSurface->h*ScaleValue);
    SDL_SetColorKey(BonusSurface, SDL_SRCCOLORKEY, CKColor);
	//*********************************
  }

  if(SystemNumber==1)
  {
	//*********************************
	// generate tiles surfaces
    TilesSurface = SDL_DisplayFormat (IMG_Load("base/amiga/tiles.png"));
    TempRect.h=TilesSurface->h*ScaleValue;
    TempRect.w=TilesSurface->w*ScaleValue;
    TilesSurface = ScaleSurface(TilesSurface, TilesSurface->w*ScaleValue, TilesSurface->h*ScaleValue);
    SDL_SetColorKey(TilesSurface, SDL_SRCCOLORKEY, CKColor);
	//*********************************

	//*********************************
	// generate Player sprites surfaces
    PlayerSpritesSurface = SDL_DisplayFormat (IMG_Load("base/amiga/player.png"));
    TempRect.h=PlayerSpritesSurface->h*ScaleValue;
    TempRect.w=PlayerSpritesSurface->w*ScaleValue;
    PlayerSpritesSurface = ScaleSurface(PlayerSpritesSurface, PlayerSpritesSurface->w*ScaleValue, PlayerSpritesSurface->h*ScaleValue);
    SDL_SetColorKey(PlayerSpritesSurface, SDL_SRCCOLORKEY, CKColor);
	//*********************************

	//*********************************
	// generate enemy sprites surfaces
    EnemySpritesSurface = SDL_DisplayFormat (IMG_Load("base/amiga/enemies.png"));
    TempRect.h=EnemySpritesSurface->h*ScaleValue;
    TempRect.w=EnemySpritesSurface->w*ScaleValue;
    EnemySpritesSurface = ScaleSurface(EnemySpritesSurface, EnemySpritesSurface->w*ScaleValue, EnemySpritesSurface->h*ScaleValue);
    SDL_SetColorKey(EnemySpritesSurface, SDL_SRCCOLORKEY, CKColor);
	//*********************************

    //*********************************
	// generate bonus sprites surfaces
    BonusSurface = SDL_DisplayFormat (IMG_Load("base/amiga/bonus.png"));
    TempRect.h=BonusSurface->h*ScaleValue;
    TempRect.w=BonusSurface->w*ScaleValue;
    BonusSurface = ScaleSurface(BonusSurface, BonusSurface->w*ScaleValue, BonusSurface->h*ScaleValue);
    SDL_SetColorKey(BonusSurface, SDL_SRCCOLORKEY, CKColor);
	//*********************************
  }


  if(!ShowIntro){Titlescreen();}
  if(ShowIntro)
  {
    if(SystemNumber==0){IntroSurface = SDL_DisplayFormat (IMG_Load("base/default/title.png"));}
    if(SystemNumber==1){IntroSurface = SDL_DisplayFormat (IMG_Load("base/amiga/title.png"));}
    if(SystemNumber==2){IntroSurface = SDL_DisplayFormat (IMG_Load("base/c64/title.png"));}
    if(SystemNumber==3){IntroSurface = SDL_DisplayFormat (IMG_Load("base/atari/title.png"));}
    if(SystemNumber==4){IntroSurface = SDL_DisplayFormat (IMG_Load("base/amstradcpc/title.png"));}
    TempRect.h=IntroSurface->h*ScaleValue;
    TempRect.w=IntroSurface->w*ScaleValue;
    IntroSurface = ScaleSurface(IntroSurface, IntroSurface->w*ScaleValue, IntroSurface->h*ScaleValue);
    Mix_FreeMusic(BackgroundMusic); //free the music
    Intro();
  }
}

void draw_pick_system_cursor(int SystemNumber)
{
  SDL_Rect SrcRect;
  SDL_Rect DstRect;
  SrcRect.x = 0*ScaleValue;
  SrcRect.y = 0*ScaleValue;
  SrcRect.w = 288*ScaleValue;
  SrcRect.h = 104*ScaleValue;
  DstRect.x = 16*ScaleValue;
  DstRect.y = 24*ScaleValue;
  DstRect.w = 288*ScaleValue;
  DstRect.h = 104*ScaleValue;
  SDL_BlitSurface(IntroSurface,&SrcRect,DisplaySurface,&DstRect);

  SrcRect.w = 272*ScaleValue;
  SrcRect.h = 88*ScaleValue;
  DstRect.x = 24*ScaleValue;
  DstRect.y = 32*ScaleValue;
  DstRect.w = 272*ScaleValue;
  DstRect.h = 88*ScaleValue;

  SrcRect.x = 0*ScaleValue;
  SrcRect.y = (104*ScaleValue)+SystemNumber*88*ScaleValue;
  SDL_BlitSurface(IntroSurface,&SrcRect,DisplaySurface,&DstRect);
  
}
